<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:template name="calc-control-digit">
        <xsl:param name="barcode-value"/>
        
        <xsl:variable name="check-digit">
            <xsl:call-template name="checksum">
                <xsl:with-param name="stringbarcode" select="string($barcode-value)"></xsl:with-param>
            </xsl:call-template>
        </xsl:variable>
        <!-- stream out full barcode string value -->
        <xsl:value-of select="concat('S',$barcode-value,string($check-digit),'s')"/>
    </xsl:template>
    
    <xsl:template name="checksum">
        <xsl:param name="stringbarcode"/>
        <xsl:param name="sum" select="0"/>
        <xsl:variable name="num" select="number(substring($stringbarcode, 1, 1))"/>
        <xsl:choose>
            <xsl:when test="string-length($stringbarcode) &gt; 0">
                <xsl:call-template name="checksum">
                    <xsl:with-param name="stringbarcode" select="substring($stringbarcode, 2)"/>
                    <xsl:with-param name="sum" select="$sum+$num"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:choose>
                    <xsl:when test="($sum mod 10) != 0">
                        <xsl:value-of select="10 - ($sum mod 10)"/>
                    </xsl:when>
                    <xsl:otherwise>0</xsl:otherwise>
                </xsl:choose>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>
